| Qore OracleSqlUtil Module Reference 1.4.3

Public Member Functions | Public Attributes | Protected Member Functions | List of all members
OracleSqlUtil::OracleDatabase Class Reference

the Oracle specialization for SqlUtil::AbstractDatabase More...

Inherits AbstractDatabase.

## Public Member Functions
| constructor (AbstractDatasource nds, *hash opts)
| creates the object from the arguments given
*OracleMaterializedView | getMaterializedView (string name)
| returns an OracleMaterializedView object for the package name given or NOTHING if the object does not exist or is not accessible
*OraclePackage | getPackage (string name)
| returns an OraclePackage object for the package name given or NOTHING if the object does not exist or is not accessible
*OracleType | getType (string name)
| returns an OracleType object for the package name given or NOTHING if the object does not exist or is not accessible
list< string > | listMaterializedViews ()
| returns a list of string materialized view names in the database
list< string > | listPackages ()
| returns a list of string package names in the database
list< string > | listSynonyms ()
| returns a list of string synonym names in the database
list< string > | listTypes ()
| returns a list of string type names in the database
ListIterator | materializedViewIterator ()
| returns an iterator listing the string materialized view names in the database
ListIterator | packageIterator ()
| returns an iterator listing the string package names in the database
bool | rebuildIndexAnalyze (AbstractIndex index, int maxh, int maxleaf)
| analyze index with ALTER INDEX ANAYZE. Then it checks INDEX_STATS for advices to rebuild. More...
bool | rebuildIndexAnalyze (string name, int maxh, int maxleaf)
| analyze index with ALTER INDEX ANAYZE. Then it checks INDEX_STATS for advices to rebuild. More...
ListIterator | synonymIterator ()
| returns an iterator listing the string synonym names in the database
ListIterator | typeIterator ()
| returns an iterator listing the string type names in the database

## Public Attributes
const | OracleAlignSchemaOptions = ...
| oracle-specific schema description / alignment options
const | OracleComputeStatisticsOptions = ...
| Options for computeStatistics()
const | OracleCreationOptions = ...
| oracle-specific generic creation options
const | OracleMaterializedViewDescriptionOptions = ...
| oracle-specific materialized view description options
const | OraclePackageDescriptionOptions = ...
| oracle-specific package description options
const | OracleRebuildIndexOptions = ...
| Options for rebuildIndex()
const | OracleReservedWords = ...
| hash of reserved words
const | OracleSchemaDescriptionOptions = ...
| oracle-specific schema description keys More...

## Protected Member Functions
| computeStatisticsImpl (*hash options)
| compute statistics implementation. See SqlUtil::AbstractDatabase::computeStatistics()
| computeStatisticsSchemaImpl (*hash options)
| compute statistics for schema - a helper method
| computeStatisticsTablesImpl (*hash options)
| compute statistics for table(s) - a helper method
hash< auto > | getAlignSchemaOptions ()
| returns driver-specific options to the base abstract class
hash< auto > | getComputeStatisticsOptions ()
| returns driver-specific options to the base abstract class
hash< auto > | getCreationOptions ()
| returns driver-specific options to the base abstract class
softint | getCurrentSequenceValueImpl (string name)
| returns the last value issued for the given sequence in the current session
softint | getNextSequenceValueImpl (string name)
| returns the next value in the given sequence
int | getPhysicalSizeImpl ()
| SqlUtil::AbstractDatabase.getPhysicalSize()
hash< auto > | getRebuildIndexOptions ()
| returns driver-specific options to the base abstract class
hash< auto > | getSchemaDescriptionOptions ()
| returns driver-specific options to the base abstract class
bool | rebuildIndexImpl (string name, *hash options)
| rebuild index implementation. See SqlUtil::AbstractDatabase::rebuildIndex()
| reclaimSpaceImpl (*hash options)
| reclaim space implementation. See SqlUtil::AbstractDatabase::reclaimSpace()
bool | supportsPackagesImpl ()
| returns True if the database supports packages
bool | supportsSequencesImpl ()
| returns True if the database supports sequences
bool | supportsTypesImpl ()
| returns True if the database supports named types

## Detailed Description

the Oracle specialization for SqlUtil::AbstractDatabase

## Member Function Documentation

## ◆ rebuildIndexAnalyze() [1/2]

bool OracleSqlUtil::OracleDatabase::rebuildIndexAnalyze | ( | AbstractIndex | index,
|  | int | maxh,
|  | int | maxleaf
| ) |  |

analyze index with ALTER INDEX ANAYZE. Then it checks INDEX_STATS for advices to rebuild.

Outputs of this method are hints only. Real investigation of index is strongly recommended.

Warning
  content of this method can be changed anytime when there will be any better way how to analyze indexes.

Parameters

  index | an AbstractIndex to analyze
  maxh | maximum oracle index height before rebuilding index
  maxleaf | maximum oracle percentage of deleted leaf nodes before rebuilding index

Returns
  bool True for "suggested for rebuilding", False for "no action needed"

Exceptions

  ANALYZE-INDEX-ERROR | if there are no data in INDEX_STATS table

## ◆ rebuildIndexAnalyze() [2/2]

bool OracleSqlUtil::OracleDatabase::rebuildIndexAnalyze | ( | string | name,
|  | int | maxh,
|  | int | maxleaf
| ) |  |

analyze index with ALTER INDEX ANAYZE. Then it checks INDEX_STATS for advices to rebuild.

Outputs of this method are hints only. Real investigation of index is strongly recommended.

Warning
  content of this method can be changed anytime when there will be any better way how to analyze indexes.

Parameters

  name | index name
  maxh | maximum oracle index height before rebuilding index
  maxleaf | maximum oracle percentage of deleted leaf nodes before rebuilding index

Returns
  bool True for "suggested for rebuilding", False for "no action needed"

Exceptions

  ANALYZE-INDEX-ERROR | if there are no data in INDEX_STATS table

## Member Data Documentation

## ◆ OracleSchemaDescriptionOptions

const OracleSqlUtil::OracleDatabase::OracleSchemaDescriptionOptions = ...

oracle-specific schema description keys

This constant extends SqlUtil::AbstractDatabase::SchemaDescriptionOptions as returned by OracleSqlUtil::OracleDatabase::getSchemaDescriptionOptions with the following Oracle-specific keys:

- `types:` for Oracle type definitions
- `type_map:` to automatically renaming Oracle types during schema alignment
- `packages:` for Oracle package descriptions
- `package_map:` for automatically renaming Oracle types during schema alignment
- `materialized_views:` for Oracle materialized view descriptions
- `materialized_view_map:` for automatically renaming Oracle materialized views during schema alignment